#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Threading;

namespace HeuristicLab.Core {
  /// <summary>
  /// Interface to represent an operator.
  /// </summary>
  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("B33272FA-A1E8-44F0-B5A2-4C5282ED9F8C")]
  public interface IOperator : IParameterizedNamedItem {
    bool Breakpoint { get; set; }

    IOperation Execute(IExecutionContext context, CancellationToken cancellationToken);

    event EventHandler BreakpointChanged;
    event EventHandler Executed;
  }
}
